# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['FullBackupMigrationArgs', 'FullBackupMigration']

@pulumi.input_type
class FullBackupMigrationArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 migration_name: pulumi.Input[str],
                 recovery_type: pulumi.Input[str],
                 upload_type: pulumi.Input[str],
                 backup_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a FullBackupMigration resource.
        :param pulumi.Input[str] instance_id: ID of imported target instance.
        :param pulumi.Input[str] migration_name: Task name.
        :param pulumi.Input[str] recovery_type: Migration task restoration type. FULL: full backup restoration, FULL_LOG: full backup and transaction log restoration, FULL_DIFF: full backup and differential backup restoration.
        :param pulumi.Input[str] upload_type: Backup upload type. COS_URL: the backup is stored in users Cloud Object Storage, with URL provided. COS_UPLOAD: the backup is stored in the applications Cloud Object Storage and needs to be uploaded by the user.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] backup_files: If the UploadType is COS_URL, fill in the URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "migration_name", migration_name)
        pulumi.set(__self__, "recovery_type", recovery_type)
        pulumi.set(__self__, "upload_type", upload_type)
        if backup_files is not None:
            pulumi.set(__self__, "backup_files", backup_files)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        ID of imported target instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="migrationName")
    def migration_name(self) -> pulumi.Input[str]:
        """
        Task name.
        """
        return pulumi.get(self, "migration_name")

    @migration_name.setter
    def migration_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "migration_name", value)

    @property
    @pulumi.getter(name="recoveryType")
    def recovery_type(self) -> pulumi.Input[str]:
        """
        Migration task restoration type. FULL: full backup restoration, FULL_LOG: full backup and transaction log restoration, FULL_DIFF: full backup and differential backup restoration.
        """
        return pulumi.get(self, "recovery_type")

    @recovery_type.setter
    def recovery_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "recovery_type", value)

    @property
    @pulumi.getter(name="uploadType")
    def upload_type(self) -> pulumi.Input[str]:
        """
        Backup upload type. COS_URL: the backup is stored in users Cloud Object Storage, with URL provided. COS_UPLOAD: the backup is stored in the applications Cloud Object Storage and needs to be uploaded by the user.
        """
        return pulumi.get(self, "upload_type")

    @upload_type.setter
    def upload_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "upload_type", value)

    @property
    @pulumi.getter(name="backupFiles")
    def backup_files(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        If the UploadType is COS_URL, fill in the URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        """
        return pulumi.get(self, "backup_files")

    @backup_files.setter
    def backup_files(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "backup_files", value)


@pulumi.input_type
class _FullBackupMigrationState:
    def __init__(__self__, *,
                 backup_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 migration_name: Optional[pulumi.Input[str]] = None,
                 recovery_type: Optional[pulumi.Input[str]] = None,
                 upload_type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering FullBackupMigration resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] backup_files: If the UploadType is COS_URL, fill in the URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        :param pulumi.Input[str] instance_id: ID of imported target instance.
        :param pulumi.Input[str] migration_name: Task name.
        :param pulumi.Input[str] recovery_type: Migration task restoration type. FULL: full backup restoration, FULL_LOG: full backup and transaction log restoration, FULL_DIFF: full backup and differential backup restoration.
        :param pulumi.Input[str] upload_type: Backup upload type. COS_URL: the backup is stored in users Cloud Object Storage, with URL provided. COS_UPLOAD: the backup is stored in the applications Cloud Object Storage and needs to be uploaded by the user.
        """
        if backup_files is not None:
            pulumi.set(__self__, "backup_files", backup_files)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if migration_name is not None:
            pulumi.set(__self__, "migration_name", migration_name)
        if recovery_type is not None:
            pulumi.set(__self__, "recovery_type", recovery_type)
        if upload_type is not None:
            pulumi.set(__self__, "upload_type", upload_type)

    @property
    @pulumi.getter(name="backupFiles")
    def backup_files(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        If the UploadType is COS_URL, fill in the URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        """
        return pulumi.get(self, "backup_files")

    @backup_files.setter
    def backup_files(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "backup_files", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of imported target instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="migrationName")
    def migration_name(self) -> Optional[pulumi.Input[str]]:
        """
        Task name.
        """
        return pulumi.get(self, "migration_name")

    @migration_name.setter
    def migration_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "migration_name", value)

    @property
    @pulumi.getter(name="recoveryType")
    def recovery_type(self) -> Optional[pulumi.Input[str]]:
        """
        Migration task restoration type. FULL: full backup restoration, FULL_LOG: full backup and transaction log restoration, FULL_DIFF: full backup and differential backup restoration.
        """
        return pulumi.get(self, "recovery_type")

    @recovery_type.setter
    def recovery_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "recovery_type", value)

    @property
    @pulumi.getter(name="uploadType")
    def upload_type(self) -> Optional[pulumi.Input[str]]:
        """
        Backup upload type. COS_URL: the backup is stored in users Cloud Object Storage, with URL provided. COS_UPLOAD: the backup is stored in the applications Cloud Object Storage and needs to be uploaded by the user.
        """
        return pulumi.get(self, "upload_type")

    @upload_type.setter
    def upload_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "upload_type", value)


class FullBackupMigration(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 backup_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 migration_name: Optional[pulumi.Input[str]] = None,
                 recovery_type: Optional[pulumi.Input[str]] = None,
                 upload_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a sqlserver full_backup_migration

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        my_migration = tencentcloud.sqlserver.FullBackupMigration("myMigration",
            backup_files=[],
            instance_id="mssql-qelbzgwf",
            migration_name="migration_test",
            recovery_type="FULL",
            upload_type="COS_URL")
        ```

        ## Import

        sqlserver full_backup_migration can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Sqlserver/fullBackupMigration:FullBackupMigration full_backup_migration full_backup_migration_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] backup_files: If the UploadType is COS_URL, fill in the URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        :param pulumi.Input[str] instance_id: ID of imported target instance.
        :param pulumi.Input[str] migration_name: Task name.
        :param pulumi.Input[str] recovery_type: Migration task restoration type. FULL: full backup restoration, FULL_LOG: full backup and transaction log restoration, FULL_DIFF: full backup and differential backup restoration.
        :param pulumi.Input[str] upload_type: Backup upload type. COS_URL: the backup is stored in users Cloud Object Storage, with URL provided. COS_UPLOAD: the backup is stored in the applications Cloud Object Storage and needs to be uploaded by the user.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FullBackupMigrationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a sqlserver full_backup_migration

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        my_migration = tencentcloud.sqlserver.FullBackupMigration("myMigration",
            backup_files=[],
            instance_id="mssql-qelbzgwf",
            migration_name="migration_test",
            recovery_type="FULL",
            upload_type="COS_URL")
        ```

        ## Import

        sqlserver full_backup_migration can be imported using the id, e.g.

        ```sh
         $ pulumi import tencentcloud:Sqlserver/fullBackupMigration:FullBackupMigration full_backup_migration full_backup_migration_id
        ```

        :param str resource_name: The name of the resource.
        :param FullBackupMigrationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FullBackupMigrationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 backup_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 migration_name: Optional[pulumi.Input[str]] = None,
                 recovery_type: Optional[pulumi.Input[str]] = None,
                 upload_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FullBackupMigrationArgs.__new__(FullBackupMigrationArgs)

            __props__.__dict__["backup_files"] = backup_files
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if migration_name is None and not opts.urn:
                raise TypeError("Missing required property 'migration_name'")
            __props__.__dict__["migration_name"] = migration_name
            if recovery_type is None and not opts.urn:
                raise TypeError("Missing required property 'recovery_type'")
            __props__.__dict__["recovery_type"] = recovery_type
            if upload_type is None and not opts.urn:
                raise TypeError("Missing required property 'upload_type'")
            __props__.__dict__["upload_type"] = upload_type
        super(FullBackupMigration, __self__).__init__(
            'tencentcloud:Sqlserver/fullBackupMigration:FullBackupMigration',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            backup_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            migration_name: Optional[pulumi.Input[str]] = None,
            recovery_type: Optional[pulumi.Input[str]] = None,
            upload_type: Optional[pulumi.Input[str]] = None) -> 'FullBackupMigration':
        """
        Get an existing FullBackupMigration resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] backup_files: If the UploadType is COS_URL, fill in the URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        :param pulumi.Input[str] instance_id: ID of imported target instance.
        :param pulumi.Input[str] migration_name: Task name.
        :param pulumi.Input[str] recovery_type: Migration task restoration type. FULL: full backup restoration, FULL_LOG: full backup and transaction log restoration, FULL_DIFF: full backup and differential backup restoration.
        :param pulumi.Input[str] upload_type: Backup upload type. COS_URL: the backup is stored in users Cloud Object Storage, with URL provided. COS_UPLOAD: the backup is stored in the applications Cloud Object Storage and needs to be uploaded by the user.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _FullBackupMigrationState.__new__(_FullBackupMigrationState)

        __props__.__dict__["backup_files"] = backup_files
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["migration_name"] = migration_name
        __props__.__dict__["recovery_type"] = recovery_type
        __props__.__dict__["upload_type"] = upload_type
        return FullBackupMigration(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="backupFiles")
    def backup_files(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        If the UploadType is COS_URL, fill in the URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        """
        return pulumi.get(self, "backup_files")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        ID of imported target instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="migrationName")
    def migration_name(self) -> pulumi.Output[str]:
        """
        Task name.
        """
        return pulumi.get(self, "migration_name")

    @property
    @pulumi.getter(name="recoveryType")
    def recovery_type(self) -> pulumi.Output[str]:
        """
        Migration task restoration type. FULL: full backup restoration, FULL_LOG: full backup and transaction log restoration, FULL_DIFF: full backup and differential backup restoration.
        """
        return pulumi.get(self, "recovery_type")

    @property
    @pulumi.getter(name="uploadType")
    def upload_type(self) -> pulumi.Output[str]:
        """
        Backup upload type. COS_URL: the backup is stored in users Cloud Object Storage, with URL provided. COS_UPLOAD: the backup is stored in the applications Cloud Object Storage and needs to be uploaded by the user.
        """
        return pulumi.get(self, "upload_type")

